const path = require('path')

const noop = () => {}

const TMap = {
  tap: 'tap',
  async: 'tapAsync',
  promise: 'tapPromise'
}

function hookTap(compiler, hook, fn, name, type = 'tap') {
  if (compiler.hooks) {
    hook = hook.replace(/-(\w)/g, function(all, letter) {
      return letter.toUpperCase()
    })
    compiler.hooks[hook][TMap[type] || 'tap'](name, fn)
  } else {
    compiler.plugin(hook, fn)
  }
}
module.exports = hookTap
