const hookTap = require('./hookTap')
const {ConcatSource,RawSource} = require('webpack-sources')

class ReplacePlugin {
  constructor(need){
    this.need = need
  }
  apply(compiler) {
    let self = this
    hookTap(
      compiler,
      'emit',
      function(compilation, callback) {
        Object.keys(compilation.assets).forEach(function(key){
            let item = compilation.assets[key]
            if(item instanceof ConcatSource && self.need === true){
              let str = item.source().replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
              compilation.assets[key] = new RawSource(str)
            }
        })
        callback()
      },
      'replace-plugin',
      'async'
    )
  }
}
module.exports = ReplacePlugin
