const _ = require ('lodash')
const webpack = require ('webpack')
const merge = require ('webpack-merge')
const webpackConfig = require ('./webpackConfig')

module.exports = function (program, type) {
  const base = webpackConfig (program, type)
  const baseWebpack = base.webpack

  const plugins = []

  const devPlugins = [
    new webpack.NamedModulesPlugin (),
    new webpack.NamedChunksPlugin ()
  ]

  Array.prototype.push.apply (plugins, devPlugins)

  const devWebpackCfg = {
    plugins: plugins
  }

  const mergeConfig = merge.smart (baseWebpack, devWebpackCfg)

  base.webpack = mergeConfig

  return base
}
