const webpack = require("webpack");
const path = require("path");
const fs = require('fs');
const iffind = require('./ifFind')
module.exports = function(program) {
  let plugins = [];
  let alias = {};

  let intactVue = path.resolve(
    process.cwd(),
    "node_modules/intact-vue/package.json"
  );


  let _findIntactVue = iffind('intact-vue')
  if(_findIntactVue){
    alias["intact$"] = "intact-vue/dist/intact.vue.js";
    alias["@babel/runtime-corejs3/helpers/inherits"] = path.resolve(__dirname, 'inheritsLoose.js')
  }

  let _findIntact = iffind('intact')
  if(_findIntact){
    plugins.push(
      new webpack.ProvidePlugin({
        Intact: "intact"
      })
    );
  }

  return {
    resolve: {
      extensions: [".vdt"],
      alias: alias
    },
    plugins: plugins,
    module: {
      rules: [
        {
          test: /\.vdt$/,
          use: [
            "happypack/loader?id=babel",
            {
              loader: "vdt-loader",
              options: {
                delimiters: ["{{", "}}"],
                skipWhitespace: true,
                noWith: true
              }
            }
          ]
        }
      ]
    }
  };
};
