const path = require("path");
const fs = require("fs");

module.exports = function stylusConf(ksr) {
  const options = {
    "include css": true,
    "resolve url": true,
    sourceMap: false
  };

  let theme = (ksr.stylTheme || "").replace(/^(\~)(.*)/, function(all, a, b) {
    return path.resolve(process.cwd(), "node_modules", b);
  });

  theme = theme.replace(/^(\@)(.*)/, function(all, a, b) {
    return path.resolve(process.cwd(), b);
  });

  const defaultThemes = ksr.pathConvert(theme);
  let statPath;
  try {
    statPath = fs.statSync(defaultThemes);
  } catch (error) {}
  if (statPath && statPath.isFile()) {
    options["import"] = defaultThemes;
  }
  return options;
};
